.386
.model	flat, stdcall
option	casemap:none

include		windows.inc
include		kernel32.inc
include		user32.inc
include		masm32.inc

includelib	user32.lib
includelib	kernel32.lib
includelib 	masm32.lib
include c:\masm32\macros\macros.asm
include c:\sqlite3.inc								;old includes
includelib c:\sqlite3.lib							;

;include c:\winasm\projects\sqlite\sqlite3.inc		;newer includes
;includelib c:\winasm\projects\sqlite\sqlite3.lib	;

showentriescallback proto :DWORD, :DWORD, :DWORD, :DWORD

.data
MsgCaption      db "WinAsm Template",0
MsgBoxText      db "This is a bare bones exe application.",0
szDatabase		db "sample.db",0

szcreatetable db "CREATE TABLE New (pkey INTEGER PRIMARY KEY, field TEXT UNIQUE);",0
errortableexists db "table New already exists",0

szinsert1 db "INSERT INTO New(field) VALUES ('One');",0
szinsert2 db "INSERT INTO New(field) VALUES ('Two');",0
szinsert3 db "INSERT INTO New(field) VALUES ('Three');",0
szinsert4 db "INSERT INTO New(field) VALUES ('Four');",0
szinsert5 db "INSERT INTO New(field) VALUES ('Five');",0

szselect db "SELECT field FROM New;", 0
.data?
hDatabase		HANDLE ?
.code
start:
	call opendatabase
	call createtable
	call insertentries
	call showentries
	call closedatabase
	;invoke MessageBox, NULL,addr MsgBoxText, addr MsgCaption, MB_OK
	invoke ExitProcess,NULL
	
	
opendatabase proc
LOCAL errormsg:DWORD
invoke sqlite3_open, addr szDatabase, addr hDatabase
.if eax == SQLITE_OK
	fn MessageBox, NULL, "Database opened successfully", "Success", MB_OK
.endif
	ret
opendatabase endp

closedatabase proc
invoke sqlite3_close, hDatabase
.if eax == SQLITE_OK
	fn MessageBox, NULL, "Database closed successfully", "Success", MB_OK
.endif
	ret
closedatabase endp

createtable proc
LOCAL errormsg:DWORD

invoke sqlite3_exec, hDatabase, addr szcreatetable, NULL, NULL, addr errormsg
.if eax == SQLITE_OK
;fn MessageBox, NULL, "Table created successfully", "Success", MB_OK
mov eax, 1
.else
invoke szCmp, errormsg, addr errortableexists
	.if eax != 0
	;the table already exists (continue)
	mov eax, 1
	.else
	fn MessageBox, NULL, errormsg, "Error", MB_OK
	invoke sqlite3_free, errormsg
	xor eax, eax
	.endif
.endif
	ret
createtable endp

insertentries proc
LOCAL errormsg:DWORD

invoke sqlite3_exec, hDatabase, addr szinsert1, NULL, NULL, addr errormsg
.if eax == SQLITE_OK
;fn MessageBox, NULL, "Data entered successfully", "Success", MB_OK
.else
fn MessageBox, NULL, errormsg, "Error", MB_OK
invoke sqlite3_free, errormsg
.endif

invoke sqlite3_exec, hDatabase, addr szinsert2, NULL, NULL, addr errormsg
.if eax == SQLITE_OK
;fn MessageBox, NULL, "Data entered successfully", "Success", MB_OK
.else
fn MessageBox, NULL, errormsg, "Error", MB_OK
invoke sqlite3_free, errormsg
.endif

invoke sqlite3_exec, hDatabase, addr szinsert3, NULL, NULL, addr errormsg
.if eax == SQLITE_OK
;fn MessageBox, NULL, "Data entered successfully", "Success", MB_OK
.else
fn MessageBox, NULL, errormsg, "Error", MB_OK
invoke sqlite3_free, errormsg
.endif

invoke sqlite3_exec, hDatabase, addr szinsert4, NULL, NULL, addr errormsg
.if eax == SQLITE_OK
;fn MessageBox, NULL, "Data entered successfully", "Success", MB_OK
.else
fn MessageBox, NULL, errormsg, "Error", MB_OK
invoke sqlite3_free, errormsg
.endif

invoke sqlite3_exec, hDatabase, addr szinsert5, NULL, NULL, addr errormsg
.if eax == SQLITE_OK
;fn MessageBox, NULL, "Data entered successfully", "Success", MB_OK
.else
fn MessageBox, NULL, errormsg, "Error", MB_OK
invoke sqlite3_free, errormsg
.endif


	ret
insertentries endp

showentries proc
LOCAL errormsg:DWORD
invoke sqlite3_exec, hDatabase, addr szselect, addr showentriescallback, NULL, addr errormsg
.if eax == SQLITE_ERROR
fn MessageBox, NULL, errormsg, "Error: showentries", MB_OK
invoke sqlite3_free, errormsg
.endif

	ret
showentries endp

showentriescallback proc lvrow:DWORD, numcol:DWORD, colvalarray:DWORD, colnamearray:DWORD

mov eax, colvalarray
mov eax, [eax]
fn MessageBox, NULL, eax, "This is your entry:", MB_OK
xor eax, eax										;must always return zero or we abort
	ret
showentriescallback endp
end start
